"""
Authors: Peter Mawhorter
Consulted:
Date: 2024-11-24
Purpose: Tests for the plaid.py task.
"""

# Import our testing library
import optimism

# Import the "Abstract Syntax Tree" library from Python builtins
import ast

# Import your code
import plaid

# Call your code to demonstrate
print("Your plaid pattern looks like this:")
plaid.plaid('.', '#', '@')

checkFile = optimism.testFile('plaid.py')

# Check that the solution does NOT use these ANYWHERE...
# Conditionals
checkFile.checkCodeContains(optimism.IfElse(n=0))
# If/else expressions
checkFile.checkCodeContains(optimism.SpecificNode(ast.IfExp, n=0))
# Loops
checkFile.checkCodeContains(optimism.Loop(n=0))

# We set up a manager to do tests of the plaid function
tester = optimism.testFunctionMaybe(plaid, "plaid")

# The 'plaid' function must...
# Calls to 'print'
tester.checkCodeContains(optimism.Call("print", n=0))
# At most 6 function calls
tester.checkCodeContains(optimism.Call(max=6))
# Has exactly 3 arguments
tester.checkCodeContains(optimism.Def("plaid", nArgs=3))

# Two different tests with different characters for the
# ground/stripe.join parts.
tester.case(' ', '#', '@').checkPrintedLines(
'   #   #   #   ',
'   #   #   #   ',
'   #   #   #   ',
'###@###@###@###',
'   #   #   #   ',
'   #   #   #   ',
'   #   #   #   ',
'###@###@###@###',
'   #   #   #   ',
'   #   #   #   ',
'   #   #   #   ',
'###@###@###@###',
'   #   #   #   ',
'   #   #   #   ',
'   #   #   #   '
)

tester.case('.', '*', '%').checkPrintedLines(
'...*...*...*...',
'...*...*...*...',
'...*...*...*...',
'***%***%***%***',
'...*...*...*...',
'...*...*...*...',
'...*...*...*...',
'***%***%***%***',
'...*...*...*...',
'...*...*...*...',
'...*...*...*...',
'***%***%***%***',
'...*...*...*...',
'...*...*...*...',
'...*...*...*...'
)
